

IF(NOT TARGET cabal)
    ADD_CUSTOM_TARGET( cabal ALL )

ENDIF()

MACRO( CABAL_ADD_SOURCE )

    MESSAGE("Addind source: " ${PROJECT_SOURCE_DIR} )
    SET_PROPERTY(GLOBAL APPEND PROPERTY CABAL_SOURCE_PATH ${PROJECT_SOURCE_DIR}) 

ENDMACRO( CABAL_ADD_SOURCE )

MACRO( CABAL_BUILD name )

    ADD_CUSTOM_TARGET( cabal_${PROJECT_NAME}_${name}_directory_generation COMMAND ${CMAKE_COMMAND} -E make_directory cabal/ ) 


    ADD_CUSTOM_COMMAND( OUTPUT cabal.sandbox.config 
                        COMMAND cabal ARGS sandbox init --sandbox=./sandbox
                        DEPENDS cabal_${PROJECT_NAME}_${name}_directory_generation
                        WORKING_DIRECTORY cabal/
                        )
    ADD_CUSTOM_TARGET( cabal_${PROJECT_NAME}_${name}_add_sources DEPENDS cabal.sandbox.config  )
    

    GET_PROPERTY(CABAL_SOURCE_PATH GLOBAL PROPERTY CABAL_SOURCE_PATH)

    FOREACH(PATH ${CABAL_SOURCE_PATH})
        ADD_CUSTOM_COMMAND( TARGET cabal_${PROJECT_NAME}_${name}_add_sources
                        PRE_BUILD
                        COMMAND cabal sandbox add-source ${PATH} --snapshot
                        WORKING_DIRECTORY cabal/
                        VERBATIM
                        )
        MESSAGE(${PATH})

    ENDFOREACH(PATH)

    ADD_CUSTOM_COMMAND( TARGET cabal_${PROJECT_NAME}_${name}_add_sources
                    PRE_BUILD
                    COMMAND cabal sandbox add-source ${PROJECT_SOURCE_DIR} --snapshot
                    WORKING_DIRECTORY cabal/
                    VERBATIM
                    )

    ADD_CUSTOM_TARGET( cabal_${PROJECT_NAME}_${name}_build
        COMMAND cabal install schpin-koke --enable-executable-dynamic --enable-shared --ghc-option=-dynamic 
        WORKING_DIRECTORY cabal/
        DEPENDS cabal_${PROJECT_NAME}_${name}_add_sources
        VERBATIM
        )

    ADD_CUSTOM_COMMAND(TARGET cabal_${PROJECT_NAME}_${name}_build 
        POST_BUILD
        COMMAND mkdir ARGS --parent ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION} 
        COMMAND ln ARGS -s ${CMAKE_CURRENT_BINARY_DIR}/cabal/sandbox/bin/schpin-koke
            ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION}/
        DEPENDS cabal_${PROJECT_NAME}_${name}_build
        VERBATIM
        )

    ADD_DEPENDENCIES( cabal cabal_${PROJECT_NAME}_${name}_build )
    

    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/cabal/sandbox/bin/schpin-koke DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

ENDMACRO( CABAL_BUILD )
